#include <malloc.h>

//#include "trithorpe.h"

//extern "C" {
    //void* malloc( int );
    //void free( const void* );
    //int write( int, const void*, int );
//}

int count_new;
int count_delete;
int count_new_array;
int count_delete_array;

void* operator new( unsigned n ) {
    ++ count_new;
    void* p= malloc(n);
//fprintf(stderr,"\nM %d %d\n", p, n );
    return p;
}
void* operator new [] ( unsigned n ) {
    ++ count_new_array;
    void* p= malloc(n);
//fprintf(stderr,"\nMA %d %d\n", p, n );
    return p;
}

void operator delete(void* p) {
    ++ count_delete;
//fprintf(stderr,"\nD %d\n", p );
    free(p);
}
void operator delete [] (void* p) {
    ++ count_delete_array;
//fprintf(stderr,"\nDA %d\n", p );
    free(p);
}



#include <stdio.h>
#include <unistd.h>

int StrLen(const char* s);

int PutcStdout( int c ) 
{
    char ch= (char) c;
    int cc= write( 1, &ch, 1 );
    return ! (cc==1);
}

int PutcStderr( int c ) 
{
    char ch= (char) c;
    int cc= write( 2, &ch, 1 );
    return ! (cc==1);
}


int PutsStdout( const char buf[], int len )
{
    int cc= write( 1, buf, len );
    return ! (cc==len);
}

int PutsStderr( const char buf[], int len )
{
    int cc= write( 2, buf, len );
    return ! (cc==len);
}

static char* CRASH= 0;  // dereferencing NULL will bomb us
void Bomb(const char*s)
{
    char* banner= "\nBOMBING: ";
    PutsStderr( banner, StrLen(banner) );

    PutsStderr( s, StrLen(s) );
    PutcStderr( '\n' );
    PutcStderr( *CRASH );
}

#ifdef MINIMAL

// END
int __gxx_personality_v0;
int __cxa_pure_virtual;

extern "C" {
    void _Unwind_Resume() {}
    void abort() { Bomb("abort"); }
}
#endif
